﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CutScript : MonoBehaviour
{
    public GameObject cube;
    public Material tempMat; 
    public GameObject jumpFloodCamGameObject;
    private Camera jumpFloodCam;


    public GameObject house;
    public Renderer[] matList; 


    void Start()
    {
        this.GetComponent<Camera>().depthTextureMode = DepthTextureMode.Depth;     

    }

    // Update is called once per frame
    /// <summary>
    /// Set the jump-flood depth texture in all materials.
    void Update()
    {
        jumpFloodCam = jumpFloodCamGameObject.GetComponent<Camera>();

        //this is possible instead of setting all materials in foreach-loop from below, but then there is everything cutted away in the edit mode
        //Shader.SetGlobalTexture("_JumpFloodDepthTex", jumpFloodCam.targetTexture);


        //Set jumpfloodTex in shader of all House-Materials
        matList = house.GetComponentsInChildren<Renderer>();
        foreach (Renderer rend in matList)
        {
            if (jumpFloodCam.targetTexture != null)
            {
                for (int i = 0; i < rend.materials.Length; i++)
                {
                    rend.materials[i].SetTexture("_JumpFloodDepthTex", jumpFloodCam.targetTexture);
                }
            }
        }

        foreach (Renderer rend in cube.GetComponentsInChildren<Renderer>())
        {
            if (jumpFloodCam.targetTexture != null)
            {
                for (int i = 0; i < rend.materials.Length; i++)
                {
                    rend.materials[i].SetTexture("_JumpFloodDepthTex", jumpFloodCam.targetTexture);
                }
            }
        }


        //close if pressing Esc
        if (Input.GetKey("escape"))
        {
            Application.Quit();
        }
    }
}
