﻿Shader "Custom/PrepareForJumpFloodShader"
{
	Properties
	{
		_MainTex("Texture", 2D) = "white" {}
		_WriteDepth("Write Depth", int) = 0
	}
		SubShader
		{
			Pass
			{
				CGPROGRAM

				#pragma vertex vert
				#pragma fragment frag

				#include "UnityCG.cginc"

				sampler2D _MainTex;
				int _WriteDepth;

				struct appdata
				{
					float4 vertex : POSITION;
				};

				struct v2f
				{
					float4 vertex : SV_POSITION;
					float4 screenPos : TEXCOORD1;
				};

				v2f vert(appdata v)
				{
					v2f o;
					o.vertex = UnityObjectToClipPos(v.vertex);
					o.screenPos = ComputeScreenPos(o.vertex);
					return o;
				}

				fixed4 frag(v2f i) : SV_Target
				{
					fixed2 screenUV = i.screenPos.xy / i.screenPos.w;
					fixed4 inputSample = tex2D(_MainTex, screenUV);

					// _MainTex: r = linearDepth, g = 0/1, b = ..., a = ...
					if (inputSample.g == 1) {
						if (_WriteDepth == 1) {
							return fixed4(inputSample.r, 0, 0, 0);
						}
						else {
							return fixed4(screenUV.x, screenUV.y, inputSample.b, inputSample.a);
						}
					}
					return fixed4(0, 0, 0, 0);
				}
				ENDCG
			}
		}
}
